Index: trunk/src/lua/lua_state.cc
===================================================================
--- trunk/src/lua/lua_state.cc	(revision 395)
+++ trunk/src/lua/lua_state.cc	(revision 399)
@@ -80,5 +80,5 @@
 }
 
-void lua::state_wrapper::register_native_function( lfunction f, string_ref name )
+void lua::state_wrapper::register_native_function( lfunction f, string_view name )
 {
 	if ( m_global ) push_global_table();
@@ -171,5 +171,5 @@
 }
 
-bool lua::table_guard::has_field( string_ref element )
+bool lua::table_guard::has_field( string_view element )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -179,5 +179,5 @@
 }
 
-std::string lua::table_guard::get_std_string( string_ref element, string_ref defval /*= string_ref() */ )
+std::string lua::table_guard::get_std_string( string_view element, string_view defval /*= string_view() */ )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -198,5 +198,5 @@
 }
 
-const_string lua::table_guard::get_string( string_ref element, string_ref defval /*= string_ref() */ )
+const_string lua::table_guard::get_string( string_view element, string_view defval /*= string_view() */ )
 {
  	lua_getfield( m_state, -1, element.data() );
@@ -217,5 +217,5 @@
 }
 
-char lua::table_guard::get_char( string_ref element, char defval /*= "" */ )
+char lua::table_guard::get_char( string_view element, char defval /*= "" */ )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -225,5 +225,5 @@
 }
 
-int lua::table_guard::get_integer( string_ref element, int defval /*= "" */ )
+int lua::table_guard::get_integer( string_view element, int defval /*= "" */ )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -233,5 +233,5 @@
 }
 
-unsigned lua::table_guard::get_unsigned( string_ref element, unsigned defval /*= "" */ )
+unsigned lua::table_guard::get_unsigned( string_view element, unsigned defval /*= "" */ )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -241,5 +241,5 @@
 }
 
-double lua::table_guard::get_double( string_ref element, double defval /*= "" */ )
+double lua::table_guard::get_double( string_view element, double defval /*= "" */ )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -250,5 +250,5 @@
 
 
-float nv::lua::table_guard::get_float( string_ref element, float defval /*= 0.0 */ )
+float nv::lua::table_guard::get_float( string_view element, float defval /*= 0.0 */ )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -258,5 +258,5 @@
 }
 
-bool lua::table_guard::get_boolean( string_ref element, bool defval /*= "" */ )
+bool lua::table_guard::get_boolean( string_view element, bool defval /*= "" */ )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -266,5 +266,5 @@
 }
 
-bool nv::lua::table_guard::is_table( string_ref element )
+bool nv::lua::table_guard::is_table( string_view element )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -274,5 +274,5 @@
 }
 
-bool nv::lua::table_guard::is_number( string_ref element )
+bool nv::lua::table_guard::is_number( string_view element )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -282,5 +282,5 @@
 }
 
-bool nv::lua::table_guard::is_boolean( string_ref element )
+bool nv::lua::table_guard::is_boolean( string_view element )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -290,5 +290,5 @@
 }
 
-bool nv::lua::table_guard::is_string( string_ref element )
+bool nv::lua::table_guard::is_string( string_view element )
 {
 	lua_getfield( m_state, -1, element.data() );
@@ -350,5 +350,5 @@
 }
 
-int lua::state::load_string( string_ref code, string_ref name )
+int lua::state::load_string( string_view code, string_view name )
 {
 	NV_LOG_TRACE( "Loading Lua string '", name, "'");
@@ -356,5 +356,5 @@
 }
 
-int lua::state::load_file( string_ref filename )
+int lua::state::load_file( string_view filename )
 {
 	NV_LOG_NOTICE( "Loading Lua file '", filename, "'");
@@ -362,5 +362,5 @@
 }
 
-bool lua::state::do_string( string_ref code, string_ref name, int rvalues )
+bool lua::state::do_string( string_view code, string_view name, int rvalues )
 {
 	lua::stack_guard( this );
@@ -374,5 +374,5 @@
 }
 
-bool lua::state::do_file( string_ref filename )
+bool lua::state::do_file( string_view filename )
 {
 	lua::stack_guard( this );
@@ -386,5 +386,5 @@
 }
 
-int lua::state::do_current( string_ref name, int rvalues )
+int lua::state::do_current( string_view name, int rvalues )
 {
 	int result = lua_pcall(m_state, 0, rvalues, 0);
@@ -417,5 +417,5 @@
 }
 
-lua::ref lua::state::register_object( void* o, string_ref lua_name )
+lua::ref lua::state::register_object( void* o, string_view lua_name )
 {
 	if ( o == nullptr ) return lua::ref( lua::ref::none );
@@ -430,5 +430,5 @@
 }
 
-lua::ref lua::state::register_proto( string_ref id, string_ref storage )
+lua::ref lua::state::register_proto( string_view id, string_view storage )
 {
 	stack_guard guard( this );
@@ -446,5 +446,5 @@
 }
 
-void lua::state::register_native_object_method( string_ref lua_name, string_ref name, lfunction f )
+void lua::state::register_native_object_method( string_view lua_name, string_view name, lfunction f )
 {
 	stack_guard guard( this );
@@ -508,5 +508,5 @@
 }
 
-void nv::lua::state::store_metadata( ref object_index, string_ref metaname, void* pointer )
+void nv::lua::state::store_metadata( ref object_index, string_view metaname, void* pointer )
 {
 	if ( !object_index.is_valid() ) return;
@@ -518,5 +518,5 @@
 }
 
-void nv::lua::state::register_enum( string_ref name, int value )
+void nv::lua::state::register_enum( string_view name, int value )
 {
 	lua_pushinteger( m_state, value );
@@ -524,5 +524,5 @@
 }
 
-nv::lua::ref nv::lua::state::register_handle_component_impl( string_ref id, bool empty )
+nv::lua::ref nv::lua::state::register_handle_component_impl( string_view id, bool empty )
 {
 	int args = empty ? 1 : 2;
@@ -547,5 +547,5 @@
 }
 
-void nv::lua::state::unregister_handle_component_impl( string_ref id )
+void nv::lua::state::unregister_handle_component_impl( string_view id )
 {
 	NV_LUA_STACK_ASSERT( m_state, -1 );
@@ -562,5 +562,5 @@
 }
 
-void nv::lua::state::register_singleton( string_ref name, void* o )
+void nv::lua::state::register_singleton( string_view name, void* o )
 {
 	if ( o == nullptr ) return;