Index: trunk/src/core/random.cc
===================================================================
--- trunk/src/core/random.cc	(revision 395)
+++ trunk/src/core/random.cc	(revision 402)
@@ -19,5 +19,5 @@
 random::seed_type random::randomize()
 {
-	std::mt19937& rng = *(( std::mt19937* )m_data);
+	std::mt19937& rng = *( reinterpret_cast< std::mt19937* >( m_data ) );
 	seed_type seed = randomized_seed();
 	rng.seed( seed );
@@ -27,5 +27,5 @@
 void random::set_seed( random::seed_type seed /*= 0 */ )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	rng.seed( seed == 0 ? randomized_seed() : seed );
 }
@@ -39,5 +39,5 @@
 random::result_type random::rand()
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	return rng();
 }
@@ -45,5 +45,5 @@
 sint32 random::srand( sint32 val )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_int_distribution<sint32> dist( 0, val - 1 );
 	return dist( rng );
@@ -52,5 +52,5 @@
 uint32 random::urand( uint32 val )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_int_distribution<uint32> dist( 0, val - 1 );
 	return dist( rng );
@@ -59,5 +59,5 @@
 f32 random::frand( f32 val )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> dist( 0, val );
 	return dist( rng );
@@ -66,5 +66,5 @@
 sint32 random::srange( sint32 min, sint32 max )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_int_distribution<sint32> dist( min, max );
 	return dist( rng );
@@ -73,5 +73,5 @@
 uint32 random::urange( uint32 min, uint32 max )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_int_distribution<uint32> dist( min, max );
 	return dist( rng );
@@ -80,5 +80,5 @@
 f32 random::frange( f32 min, f32 max )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> dist( min, max );
 	return dist( rng );
@@ -87,5 +87,5 @@
 uint32 random::dice( uint32 count, uint32 sides )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_int_distribution<uint32> dist( 1, sides );
 	uint32 result = 0;
@@ -106,5 +106,5 @@
 nv::vec2 nv::random::precise_unit_vec2()
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> dist( 0, glm::pi<float>() * 2.f );
 	float angle = dist( rng );
@@ -114,5 +114,5 @@
 nv::vec3 nv::random::precise_unit_vec3()
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> dist11( -1.0f, 1.0f );
 	std::uniform_real_distribution<f32> dist02pi( 0.0f, 2*glm::pi<float>() );
@@ -129,5 +129,5 @@
 nv::vec2 nv::random::fast_disk_point()
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> dist( 0.0f, 1.0f );
 	float r1 = dist( rng );
@@ -140,5 +140,5 @@
 nv::vec2 nv::random::precise_disk_point()
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> unit( 0.0f, 1.0f );
 	std::uniform_real_distribution<f32> angle( 0.0f, glm::pi<float>() );
@@ -150,5 +150,5 @@
 nv::vec3 nv::random::fast_sphere_point()
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> dist01( 0.0f, 1.0f );
 	std::uniform_real_distribution<f32> dist11( -1.0f, 1.0f );
@@ -168,5 +168,5 @@
 nv::vec3 nv::random::precise_sphere_point()
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> dist01( 0.0f, 1.0f );
 	std::uniform_real_distribution<f32> dist11( -1.0f, 1.0f );
@@ -185,5 +185,5 @@
 nv::vec2 nv::random::precise_ellipse_point( const vec2& radii )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> distx( -radii.x, radii.x );
 	std::uniform_real_distribution<f32> disty( -radii.y, radii.y );
@@ -204,5 +204,5 @@
 nv::vec3 nv::random::precise_ellipsoid_point( const vec3& radii )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	std::uniform_real_distribution<f32> distx( -radii.x, radii.x );
 	std::uniform_real_distribution<f32> disty( -radii.y, radii.y );
@@ -225,5 +225,5 @@
 nv::vec2 nv::random::fast_hollow_disk_point( float iradius, float oradius )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	float idist2 = iradius * iradius;
 	float odist2 = oradius * oradius;
@@ -239,5 +239,5 @@
 nv::vec3 nv::random::fast_hollow_sphere_point( float iradius, float oradius )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	float idist3 = iradius * iradius * iradius;
 	float odist3 = oradius * oradius * oradius;
@@ -254,5 +254,5 @@
 nv::vec2 nv::random::fast_hollow_ellipse_point( const vec2& iradii, const vec2& oradii )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	vec2 iradii2 = iradii * iradii;
 	vec2 opoint     = ellipse_edge( oradii );
@@ -275,5 +275,5 @@
 nv::vec3 nv::random::fast_hollow_ellipsoid_point( const vec3& iradii, const vec3& oradii )
 {
-	std::mt19937& rng = *( ( std::mt19937* )m_data );
+	std::mt19937& rng = *( reinterpret_cast<std::mt19937*>( m_data ) );
 	vec3 iradii2 = iradii * iradii;
 	vec3 opoint     = ellipsoid_edge( oradii );